function result = SensorModel1(s)
% fucntion calculate sensor model for reading s
% e.g. s = 75;                % sensor Reading

beta = 20 * pi/180;   % 20 deg, treba previest na rad
R = 90;               % maximalna vzdialenost
MaxOcc = 0.90;        % maximalna pravdepodobnost
Tolerance = 5;

x=1:1:100;
y=1:1:100;
gridEm = ones(100,100).*0.5;
gridOc = ones(100,100).*0.5;

% meshc(x,y,gridEm);    % nakresli obrazok na zaciatku prazdnej siete
% pause;

for Row = 1:100
    for Col = 1:100
       alpha = abs(atan2((50-Row),Col));
%        alpha = atan((50-Row)/Col);
       if ( alpha < beta ) 
         r = sqrt(Col^2 + (50-Row)^2);
         if ( (r < s+Tolerance) && (r> s-Tolerance))
             gridOc(Row,Col) = ( (R-r)/(R) + (beta-alpha)/(beta) )/(2) * MaxOcc;
             % nechapem preco tieto limity tu musia byt, ale inak to nejde:
             if ( gridOc(Row,Col) < 0.5) gridOc(Row,Col) = 0.5; end
             gridEm(Row,Col) = 1 - gridOc(Row,Col); 
         else
             if ( (r < s-Tolerance) )
              gridEm(Row,Col) = ( (R-r)/(R) + (beta-alpha)/(beta) )/(2);
              % nechapem preco tieto limity tu musia byt, ale inak to nejde:
              if ( gridEm(Row,Col) < 0.5) gridEm(Row,Col) = 0.5 ; end   % nechapem preco tieto limity tu musia byt, ale inak to nejde:
              gridOc(Row,Col) = 1 - gridEm(Row,Col); 
             end
         end
       end
    end
end

gridOc(1,1) = 1;
gridOc(1,2) = 0;
meshc(x,y,gridOc);    % nakresli obrazok na zaciatku prazdnej siete

result = 1;