function result = SensorModel2(dist,alpha)
% fucntion calculate sensor model for sensor reading 'dist' at angle 'alpha'

     beta =    20 * pi/180;   % 20 deg, treba previest na rad
    alpha = alpha * pi/180;   % prevod na radiany
        R = 90;               % maximalna vzdialenost
   MaxOcc = 0.90;             % maximalna pravdepodobnost
Tolerance = 5;                % rozptyl merania s

% initialize occupancy grids: 
x=1:1:100;
y=1:1:100;
gridEm = ones(100,100).*0.5;
gridOc = ones(100,100).*0.5;

% meshc(x,y,gridEm);    % nakresli obrazok na zaciatku prazdnej siete
% pause;

for Row = 1:100
    for Col = 1:100
        
        gamma = abs(atan2(Col,(50-Row)));

        if (  (gamma < (alpha + beta)) &&  (gamma > (alpha - beta))  )  % inside a cone
        
            r = sqrt(Col^2 + (50-Row)^2);
            
         if ( (r < dist+Tolerance) && (r> dist-Tolerance))    % inside a Region I
             gridOc(Row,Col) = ( (R-r)/(R) + (beta-abs(gamma-alpha))/(beta) )/(2) * MaxOcc;
             % nechapem preco tieto limity tu musia byt, ale inak to nejde:
             if ( gridOc(Row,Col) < 0.5) gridOc(Row,Col) = 0.5; end
             gridEm(Row,Col) = 1 - gridOc(Row,Col); 
         else
             if ( (r < dist-Tolerance) )                   % inside Region II
              gridEm(Row,Col) = ( (R-r)/(R) + (beta-abs(gamma-alpha))/(beta) )/(2);
              % nechapem preco tieto limity tu musia byt, ale inak to nejde:
              if ( gridEm(Row,Col) < 0.5) gridEm(Row,Col) = 0.5 ; end   % nechapem preco tieto limity tu musia byt, ale inak to nejde:
              gridOc(Row,Col) = 1 - gridEm(Row,Col); 
             end
         end
       end
    end
end

gridOc(100,100) = 1;
gridOc(100,99) = 0;
meshc(x,y,gridOc);    % nakresli obrazok na zaciatku prazdnej siete

result = gridOc;